<template>
    <div class="box-ot">
        <div class="ot__top">
            <p class="date-ot">{{ label }}</p>
            <span class="blue"></span>
            <p class="text-date">{{ dateString }}</p>
            <flat-pickr ref="datePicker" :config="config" :value="date" @on-change="onPickerChange"/>
            <div class="ot__calendar" :id="id">
                <div style="cursor: pointer" id="calendarClick" class="calendar--head" @click="openPicker">
                    <svg class="leftIcon">
                        <use xlink:href="/img/sprite.svg#calendar-3"></use>
                    </svg>
                </div>
            </div>
        </div>
        <div class="ot__bottom">
            <div class="bottom--input">
                <label for="Day">{{ $t('analytics.form.day') }}</label>
                <input type="number" min="1" :max="maxDay" v-model.number="day" id="Day">
            </div>
            <div class="bottom--input">
                <label for="Month">{{ $t('analytics.form.month') }}</label>
                <input type="number" min="1" :max="maxMonth" v-model.number="month" id="Month">
            </div>
            <div class="bottom--input">
                <label for="Year">{{ $t('analytics.form.year') }}</label>
                <input type="number" min="0" :max="maxYear" v-model.number="year" id="Year">
            </div>
        </div>
    </div>
</template>

<script>

	export default {
		name: "DateBlock",
        props: ['label', 'date', 'minDate', 'maxDate'],
        data(){
		    return {
                day: 1,
                month: 1,
                year: 2020,
                config: {
                    wrap: true,
                    enableTime: true,
                    time_24hr: true,
                }
            }
        },
        watch: {
		    day(){
                this.emitCurrentDate();
            },
		    month(){
                this.emitCurrentDate();
            },
		    year(){
                this.emitCurrentDate();
            },
            date(){
		        this.setDateFromProps();
            },
            minDate(dateStr){
                this.$set(this.config, 'minDate', dateStr);
            },
            maxDate(dateStr){
                this.$set(this.config, 'maxDate', dateStr);
            }
        },
        computed: {
		    id(){
		        return this._uid;
            },
		    currentYear(){
		        return this.$date().year() === this.year;
            },
            maxYear(){
                return this.$date().year();
            },
            maxMonth(){
                if(this.currentYear){
                    return this.$date().month() + 1;
                }else{
                    return 12;
                }
            },
		    maxDay(){
		        if(this.date){
                    return this.dateObj.daysInMonth();
                }else{
		            return 31;
                }
            },
            dateObj(){
                return this.$date(this.date);
            },
            dateString(){
                return this.dateObj.format('DD.MM.YYYY');
            }
        },
        methods: {
		    openPicker(){
                const flatPickrInstance = this.$refs.datePicker.fp;
                flatPickrInstance._positionElement = window.document.getElementById(this.id); // eslint-disable-line
                flatPickrInstance.toggle();
            },
            setDateFromProps(){
                if(this.date){
                    this.day = this.dateObj.date();
                    this.month = this.dateObj.month() + 1;
                    this.year = this.dateObj.year();
                }
            },
            emitCurrentDate(){
                let date = this.dateObj.year(this.year).month(this.month - 1).date(this.day);
                this.$emit('change', date.toJSON());
            },
            onPickerChange(selectedDates, dateStr, instance ){
                this.$emit('change', dateStr);
                //const flatPickrInstance = this.$refs.datePicker.fp;
                //flatPickrInstance.close();
            }
        },
        mounted() {
		    this.setDateFromProps();
        }

    }
</script>

<style scoped>
    .flatpickr-input{
        display: none;
    }
</style>
